"""
This type stub file was generated by pyright.
"""

from aiwolf_nlp_common.packet.packet import Packet

"""
This type stub file was generated by pyright.
"""
class Client:
    """対戦サーバーとの通信を行うクライアントクラス.

    Attributes:
        socket (websocket.WebSocket): WebSocketクライアント.
        url (str): 対戦サーバーのURL.
        headers (list[str]): WebSocket接続時のヘッダー情報.

    Args:
        url (str): 対戦サーバーのURL.
        token (str | None): 対戦サーバーに接続するためのトークン.

    Examples:
        >>> from aiwolf_nlp_common.client import Client
        >>> client = Client("ws://localhost:10000", "token")
        >>> client.connect()
        >>> packet = client.receive()
        >>> print(packet.request)
        Request.INITIALIZE
        >>> client.close()
    """
    def __init__(self, url: str, token: str | None) -> None:
        """クライアントを初期化します.

        Args:
            url (str): 対戦サーバーのURL.
            token (str | None): 対戦サーバーに接続するためのトークン. デフォルトは None.
        """
        ...
    
    def connect(self) -> None:
        """対戦サーバーに接続します."""
        ...
    
    def receive(self) -> Packet:
        """対戦サーバーからパケットを受信します.

        Returns:
            Packet: 受信したパケット.
        """
        ...
    
    def send(self, req: str) -> None:
        """対戦サーバーにリクエストを送信します.

        Args:
            req (str): 送信するリクエスト.
        """
        ...
    
    def close(self) -> None:
        """対戦サーバーとの接続を閉じます."""
        ...
    


